"use strict";

exports.__esModule = true;
exports.default = callApiAndParseWithTimeout;

var _callApi = _interopRequireDefault(require("./callApi"));

var _rejectAfterTimeout = _interopRequireDefault(require("./rejectAfterTimeout"));

var _parseResponse = _interopRequireDefault(require("./parseResponse"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

async function callApiAndParseWithTimeout(_ref) {
  let {
    timeout,
    parseMethod
  } = _ref,
      rest = _objectWithoutPropertiesLoose(_ref, ["timeout", "parseMethod"]);

  const apiPromise = (0, _callApi.default)(rest);
  const racedPromise = typeof timeout === 'number' && timeout > 0 ? Promise.race([apiPromise, (0, _rejectAfterTimeout.default)(timeout)]) : apiPromise;
  return (0, _parseResponse.default)(racedPromise, parseMethod);
}